#ifndef KLX_LENGTHOF_HPP
#define KLX_LENGTHOF_HPP

#include "common.hpp"

//============================================================================
// <<length of array>> library
//
//	int x[30]; lengthof(x); 30졢
//	int *p;    lengthof(p); ǥѥ륨顼
//	ˤʤ褦ʥޥ lengthof ޤ
//
// [def]
//
//	lengthof  : token -> size_t
//
//		ѿ̾ǤСĹ֤ޤ
//		vc, bcc, g++ ǤϡʳΤΤϤȤ
//		ѥ륨顼ȯޤ
//
// []
//
//	dmc Ǥϡݥ󥿤ϤȤʤɤ̤ꤷƤޤޤ
//
//============================================================================

namespace klx { namespace detail {
	template<typename T,int N> typename sized_type<N>::type lengthof_impl(T (&x)[N]);
  #if KLX_COMPILER_IS_BCC
	template<typename T,int N> typename sized_type<N>::type lengthof_impl(const T (&x)[N]);
  #endif
}}

#if KLX_COMPILER_IS_NOT_DMC
	#define lengthof(arr) (sizeof(klx::detail::lengthof_impl(arr)))
#else
	#define lengthof(arr) (sizeof(arr)/sizeof((arr)[0]))
#endif



#endif // INCLUDE_GUARD
